Index: vlo/trunk/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/FacetConstants.java
===================================================================
--- vlo/trunk/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/FacetConstants.java	(revision 6810)
+++ vlo/trunk/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/FacetConstants.java	(revision 6811)
@@ -27,4 +27,6 @@
     public static final String FIELD_NATIONAL_PROJECT = "nationalProject";
     public static final String FIELD_KEYWORDS = "keywords";
+    public static final String FIELD_PROFILE = "profileName";
+    
     /**
      * Solr pseudo-field that reveals the ranking score
Index: vlo/trunk/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/StringUtils.java
===================================================================
--- vlo/trunk/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/StringUtils.java	(revision 6810)
+++ vlo/trunk/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/StringUtils.java	(revision 6811)
@@ -4,7 +4,9 @@
 import java.util.HashSet;
 import java.util.Set;
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
 
 public final class StringUtils {
-
+	
     /**
      * Converts a newlines in to html (&lt;br/&gt;), not using &lt;p&gt; because it renders differently on firefox/safari/chrome/ie etc...
@@ -71,4 +73,24 @@
         return normalizedString.toString();
     }
+    
+    public static String uncapitalizeFirstLetter(String value){
+		return value.substring(0, 1).toLowerCase() + value.substring(1);
+	}
+    
+    public static String capitalizeFirstLetter(String value){
+		return value.substring(0, 1).toUpperCase() + value.substring(1);
+	}
+        
+    public static String createStringFromArray(String... values){
+    	String res = "";
+    	
+    	for(String str: values){
+    		res += str;
+    	}
+    	
+    	return res;
+    	
+    }
+    
 
 }
Index: vlo/trunk/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/config/VloConfig.java
===================================================================
--- vlo/trunk/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/config/VloConfig.java	(revision 6810)
+++ vlo/trunk/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/config/VloConfig.java	(revision 6811)
@@ -72,4 +72,6 @@
 
     private String licenseAvailabilityMapUrl;
+    
+    private String resourceClassMapUrl;
 
     private String countryComponentUrl = "";
@@ -1026,4 +1028,12 @@
         licenseAvailabilityMapUrl = param;
     }
+    
+    public String getResourceClassMapUrl() {
+		return resourceClassMapUrl;
+	}
+
+	public void setResourceClassMapUrl(String resourceClassMapUrl) {
+		this.resourceClassMapUrl = resourceClassMapUrl;
+	}
 
     /**
Index: vlo/trunk/vlo-commons/src/test/java/eu/clarin/cmdi/vlo/config/DefaultVloConfigFactoryTest.java
===================================================================
--- vlo/trunk/vlo-commons/src/test/java/eu/clarin/cmdi/vlo/config/DefaultVloConfigFactoryTest.java	(revision 6810)
+++ vlo/trunk/vlo-commons/src/test/java/eu/clarin/cmdi/vlo/config/DefaultVloConfigFactoryTest.java	(revision 6811)
@@ -597,5 +597,5 @@
         System.out.println("getNationalProjectMapping");
 
-        String expResult = "/nationalProjectsMapping.xml";
+        String expResult = "nationalProjectsMapping.xml";
         String result = config.getNationalProjectMapping();
 
Index: vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/AvailabilityPostProcessor.java
===================================================================
--- vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/AvailabilityPostProcessor.java	(revision 6810)
+++ vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/AvailabilityPostProcessor.java	(revision 6811)
@@ -1,24 +1,6 @@
 package eu.clarin.cmdi.vlo.importer;
 
-import java.io.IOException;
-import java.io.InputStream;
-import java.net.MalformedURLException;
 import java.util.ArrayList;
-import java.util.HashMap;
 import java.util.List;
-import java.util.Map;
-import java.util.regex.Matcher;
-import java.util.regex.Pattern;
-import javax.xml.parsers.DocumentBuilder;
-import javax.xml.parsers.DocumentBuilderFactory;
-import javax.xml.parsers.ParserConfigurationException;
-import javax.xml.xpath.XPath;
-import javax.xml.xpath.XPathConstants;
-import javax.xml.xpath.XPathExpressionException;
-import javax.xml.xpath.XPathFactory;
-import org.w3c.dom.Document;
-import org.w3c.dom.Node;
-import org.w3c.dom.NodeList;
-import org.xml.sax.SAXException;
 
 /**
@@ -26,62 +8,23 @@
  * @author teckart
  */
-public class AvailabilityPostProcessor implements PostProcessor {
-
-    private static Map<String, String> availabilityMap;
-    private static final Integer MAX_LENGTH = 20;
+public class AvailabilityPostProcessor extends PostProcessorsWithControlledVocabulary {
+	
+	private static final Integer MAX_LENGTH = 20;
     private static final String OTHER_VALUE = "Other";
+    
 
     @Override
     public List<String> process(final String value) {
-        String result = value;
         List<String> resultList = new ArrayList<String>();
-
-        if (getLicenseAvailabilityMap().containsKey(value.toLowerCase())) {
-            resultList.add(getLicenseAvailabilityMap().get(value.toLowerCase()));
-        } else {
-            if (result.length() > MAX_LENGTH) {
-                resultList.add(OTHER_VALUE);
-            } else {
-                resultList.add(result.trim());
-            }
-        }
+        
+        resultList.add(normalize(value, value.length() > MAX_LENGTH? OTHER_VALUE : value.trim()));
 
         return resultList;
     }
 
-    private Map<String, String> getLicenseAvailabilityMap() {
-        if (availabilityMap == null) {
-            try {
-                // load records from file
-                availabilityMap = createControlledVocabularyMap(MetadataImporter.config.getLicenseAvailabilityMapUrl());
-            } catch (Exception e) {
-                throw new RuntimeException("Cannot instantiate postProcessor:", e);
-            }
-        }
-        return availabilityMap;
-    }
 
-    private Map<String, String> createControlledVocabularyMap(String languageNamesUrl) throws ParserConfigurationException, MalformedURLException, SAXException, XPathExpressionException, IOException {
-        Map<String, String> result = new HashMap<String, String>();
-        DocumentBuilderFactory domFactory = DocumentBuilderFactory.newInstance();
-        domFactory.setNamespaceAware(true);
-
-        InputStream mappingFileAsStream;
-        mappingFileAsStream = NationalProjectPostProcessor.class.getResourceAsStream(languageNamesUrl);
-
-        DocumentBuilder builder = domFactory.newDocumentBuilder();
-        Document doc = builder.parse(mappingFileAsStream);
-        XPath xpath = XPathFactory.newInstance().newXPath();
-        NodeList nodeList = (NodeList) xpath.evaluate("//Availability", doc, XPathConstants.NODESET);
-        for (int i = 0; i < nodeList.getLength(); i++) {
-            Node node = nodeList.item(i);
-            String availabilityName = node.getAttributes().getNamedItem("name").getTextContent();
-            NodeList childNodeList = node.getChildNodes();
-            for (int j = 0; j < childNodeList.getLength(); j++) {
-                String license = childNodeList.item(j).getTextContent().toLowerCase();
-                result.put(license, availabilityName);
-            }
-        }
-        return result;
-    }
+	@Override
+	public String getNormalizationMapURL() {
+		return MetadataImporter.config.getLicenseAvailabilityMapUrl();
+	}
 }
Index: vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/LanguageCodePostProcessor.java
===================================================================
--- vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/LanguageCodePostProcessor.java	(revision 6810)
+++ vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/LanguageCodePostProcessor.java	(revision 6811)
@@ -1,35 +1,18 @@
 package eu.clarin.cmdi.vlo.importer;
 
-import eu.clarin.cmdi.vlo.LanguageCodeUtils;
-import java.io.IOException;
-import java.io.InputStream;
-import java.net.MalformedURLException;
+import java.util.ArrayList;
+import java.util.List;
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
+
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.List;
-import java.util.Map;
-import java.util.regex.Matcher;
-import java.util.regex.Pattern;
-import javax.xml.parsers.DocumentBuilder;
-import javax.xml.parsers.DocumentBuilderFactory;
-import javax.xml.parsers.ParserConfigurationException;
-import javax.xml.xpath.XPath;
-import javax.xml.xpath.XPathConstants;
-import javax.xml.xpath.XPathExpressionException;
-import javax.xml.xpath.XPathFactory;
-import org.w3c.dom.Document;
-import org.w3c.dom.Node;
-import org.w3c.dom.NodeList;
-import org.xml.sax.SAXException;
+import eu.clarin.cmdi.vlo.LanguageCodeUtils;
 
-public class LanguageCodePostProcessor implements PostProcessor{
+public class LanguageCodePostProcessor extends PostProcessorsWithControlledVocabulary{
 
     private final static Logger LOG = LoggerFactory.getLogger(LanguageCodePostProcessor.class);
     
-    private static Map<String, String> languageNameVariantsMap = null;
-
     protected static final String CODE_PREFIX = "code:";
     protected static final String LANG_NAME_PREFIX = "name:";
@@ -57,4 +40,9 @@
         return resultList;
     }
+    
+	@Override
+	public String getNormalizationMapURL() {
+		return MetadataImporter.config.getLanguageNameVariantsUrl();
+	}
 
     protected String extractLanguageCode(String value) {
@@ -65,6 +53,5 @@
         
         // map known language name variants to their offical name
-        if(getLanguageNamesVariantsMap().containsKey(result))
-            result = getLanguageNamesVariantsMap().get(result);
+        result = normalize(result);
         
         // input is already ISO 639-3?
@@ -96,39 +83,4 @@
         return result;
     }
-    
-        private Map<String, String> getLanguageNamesVariantsMap() {
-        if (languageNameVariantsMap == null) {
-            try {
-                // load records from file, in the future this should be loaded from CLAVAS directly and the file only used as fallback
-                languageNameVariantsMap = createControlledVocabularyMap(MetadataImporter.config.getLanguageNameVariantsUrl());
-            } catch (Exception e) {
-                throw new RuntimeException("Cannot instantiate postProcessor:", e);
-            }
-        }
-        return languageNameVariantsMap;
-    }
 
-    private Map<String, String> createControlledVocabularyMap(String languageNamesUrl) throws ParserConfigurationException, MalformedURLException, SAXException, XPathExpressionException, IOException {
-        Map<String, String> result = new HashMap<String, String>();
-        DocumentBuilderFactory domFactory = DocumentBuilderFactory.newInstance();
-        domFactory.setNamespaceAware(true);
-
-        InputStream mappingFileAsStream;
-        mappingFileAsStream = NationalProjectPostProcessor.class.getResourceAsStream(languageNamesUrl);
-
-        DocumentBuilder builder = domFactory.newDocumentBuilder();
-        Document doc = builder.parse(mappingFileAsStream);
-        XPath xpath = XPathFactory.newInstance().newXPath();
-        NodeList nodeList = (NodeList) xpath.evaluate("//Language", doc, XPathConstants.NODESET);
-        for (int i = 0; i < nodeList.getLength(); i++) {
-            Node node = nodeList.item(i);
-            String languageName = node.getAttributes().getNamedItem("name").getTextContent();
-            NodeList childNodeList = node.getChildNodes();
-            for (int j = 0; j < childNodeList.getLength(); j++) {
-                String variation = childNodeList.item(j).getTextContent();
-                result.put(variation, languageName);
-            }
-        }
-        return result;
-    }
 }
Index: vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/NationalProjectPostProcessor.java
===================================================================
--- vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/NationalProjectPostProcessor.java	(revision 6810)
+++ vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/NationalProjectPostProcessor.java	(revision 6811)
@@ -1,24 +1,7 @@
 package eu.clarin.cmdi.vlo.importer;
 
-import java.io.File;
-import java.io.IOException;
-import java.io.InputStream;
 import java.util.ArrayList;
-import java.util.HashMap;
 import java.util.List;
-import java.util.Map;
-import java.util.regex.Matcher;
-import java.util.regex.Pattern;
-import javax.xml.parsers.DocumentBuilder;
-import javax.xml.parsers.DocumentBuilderFactory;
-import javax.xml.xpath.XPath;
-import javax.xml.xpath.XPathConstants;
-import javax.xml.xpath.XPathExpressionException;
-import javax.xml.xpath.XPathFactory;
-import org.apache.commons.io.FileUtils;
-import org.slf4j.Logger;
-import org.slf4j.LoggerFactory;
-import org.w3c.dom.Document;
-import org.w3c.dom.NodeList;
+
 
 /**
@@ -29,10 +12,6 @@
  *
  */
-public class NationalProjectPostProcessor extends LanguageCodePostProcessor {
+public class NationalProjectPostProcessor extends PostProcessorsWithControlledVocabulary {
 
-    private final static Logger LOG = LoggerFactory.getLogger(NationalProjectPostProcessor.class);
-
-    private static Map<String, String> nationalProjectMap = null;
-    private static Map<Pattern, String> nationalProjectRegExpMap = null;
 
     /**
@@ -45,120 +24,15 @@
     @Override
     public List<String> process(String value) {
-        String input = value.trim();
         List<String> resultList = new ArrayList<String>();
-
-        if (input != null && getMapping().containsKey(input)) {
-            resultList.add(getMapping().get(input));
-            return resultList;
-        }
-
-        for (Pattern pattern : getRegExpMapping().keySet()) {
-            Matcher matcher = pattern.matcher(input);
-            if (matcher.find()) {
-                resultList.add(getRegExpMapping().get(pattern));
-                return resultList;
-            }
-        }
-
-        resultList.add("");
+        resultList.add(normalize(value.trim(), ""));
+        
         return resultList;
     }
+    
 
-    private Map<String, String> getMapping() {
-        if (nationalProjectMap == null) {
-            getNationalProjectMapping();
-        }
-        return nationalProjectMap;
-    }
-
-    private Map<Pattern, String> getRegExpMapping() {
-        if (nationalProjectRegExpMap == null) {
-            getNationalProjectMapping();
-        }
-        return nationalProjectRegExpMap;
-    }
-
-    private void getNationalProjectMapping() {
-        String projectsMappingFile = MetadataImporter.config.getNationalProjectMapping();
-
-        if (projectsMappingFile.length() == 0) {
-            // use the packaged project mapping file
-            projectsMappingFile = "/nationalProjectsMapping.xml";
-        }
-
-        try {
-            nationalProjectMap = new HashMap<String, String>();
-            nationalProjectRegExpMap = new HashMap<Pattern, String>();
-            DocumentBuilderFactory domFactory = DocumentBuilderFactory.newInstance();
-            domFactory.setNamespaceAware(true);
-
-            DocumentBuilder builder = domFactory.newDocumentBuilder();
-            Document doc;
-
-            // first, try to open the packaged mapping file
-            InputStream mappingFileAsStream;
-            mappingFileAsStream = NationalProjectPostProcessor.class.getResourceAsStream(projectsMappingFile);
-
-            if (mappingFileAsStream != null) {
-                doc = builder.parse(mappingFileAsStream);
-            } else {
-                // the resource cannot be found inside the package, try outside
-                File mappingAsFile;
-
-                mappingAsFile = new File(projectsMappingFile);
-
-                if (!mappingAsFile.exists()) {
-                    LOG.info("National project mapping file does not exist - using minimal test file.");
-                    mappingAsFile = createMinimalMappingFile();
-                }
-                doc = builder.parse(mappingAsFile);
-            }
-
-            XPath xpath = XPathFactory.newInstance().newXPath();
-            NodeList nodeList = (NodeList) xpath.evaluate("//nationalProjectMapping", doc, XPathConstants.NODESET);
-            for (int i = 1; i <= nodeList.getLength(); i++) {
-                String mdCollectionDisplayName = xpath.evaluate("//nationalProjectMapping[" + i + "]/MdCollectionDisplayName", doc).trim();
-                String nationalProject = xpath.evaluate("//nationalProjectMapping[" + i + "]/NationalProject", doc).trim();
-                Boolean isRegExp;
-                try {
-                    isRegExp = Boolean.parseBoolean(xpath.evaluate("//nationalProjectMapping[" + i + "]/MdCollectionDisplayName/@isRegExp", doc));
-                } catch (XPathExpressionException xee) {
-                    isRegExp = false;
-                }
-                if (isRegExp == true) {
-                    nationalProjectRegExpMap.put(Pattern.compile(mdCollectionDisplayName), nationalProject);
-                } else {
-                    nationalProjectMap.put(mdCollectionDisplayName, nationalProject);
-                }
-            }
-        } catch (Exception e) {
-            throw new RuntimeException("Cannot instantiate postProcessor:", e);
-        }
-    }
-
-    /**
-     * Create temporary and minimal mapping file for testing purposes and as
-     * backup solution
-     *
-     * @return minimal file for national projects mapping (e.g. TLA: ANDES ->
-     * CLARIN-EU)
-     */
-    private File createMinimalMappingFile() {
-        String content = "";
-        content += "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>\n";
-        content += "<nationalProjects>\n";
-        content += "   <nationalProjectMapping><MdCollectionDisplayName>TLA: ANDES</MdCollectionDisplayName><NationalProject>CLARIN-EU</NationalProject></nationalProjectMapping>\n";
-        content += "   <nationalProjectMapping><MdCollectionDisplayName isRegExp=\"true\">Meertens.*</MdCollectionDisplayName><NationalProject>CLARIN-NL</NationalProject></nationalProjectMapping>\n";
-        content += "</nationalProjects>\n";
-
-        File file = null;
-        try {
-            file = File.createTempFile("vlo.nationalTestMapping", ".map");
-            FileUtils.writeStringToFile(file, content, "UTF-8");
-        } catch (IOException ioe) {
-            LOG.error("Could not create temporary national project mapping file");
-        }
-
-        return file;
-    }
+	@Override
+	public String getNormalizationMapURL() {
+		return MetadataImporter.config.getNationalProjectMapping();
+	}
+    
 }
Index: vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/OrganisationPostProcessor.java
===================================================================
--- vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/OrganisationPostProcessor.java	(revision 6810)
+++ vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/OrganisationPostProcessor.java	(revision 6811)
@@ -1,27 +1,9 @@
 package eu.clarin.cmdi.vlo.importer;
 
-import java.io.IOException;
-import java.io.InputStream;
-import java.net.MalformedURLException;
 import java.util.Arrays;
-import java.util.HashMap;
 import java.util.List;
-import java.util.Map;
-import javax.xml.parsers.DocumentBuilder;
-import javax.xml.parsers.DocumentBuilderFactory;
-import javax.xml.parsers.ParserConfigurationException;
-import javax.xml.xpath.XPath;
-import javax.xml.xpath.XPathConstants;
-import javax.xml.xpath.XPathExpressionException;
-import javax.xml.xpath.XPathFactory;
-import org.w3c.dom.Document;
-import org.w3c.dom.Node;
-import org.w3c.dom.NodeList;
-import org.xml.sax.SAXException;
 
-public class OrganisationPostProcessor implements PostProcessor {
-
-    private static Map<String, String> organisationNamesMap = null;
-
+public class OrganisationPostProcessor extends PostProcessorsWithControlledVocabulary{
+	 
     /**
      * Splits values for organisation facet at delimiter ';' and replaces
@@ -37,12 +19,16 @@
         String[] splitArray = normalizeInputString(value).split(";");
         for (int i = 0; i < splitArray.length; i++) {
-            String orgaName = splitArray[i];
-            if (getNormalizedOrganisationNamesMap().containsKey(normalizeVariant(orgaName))) {
-                splitArray[i] = getNormalizedOrganisationNamesMap().get(normalizeVariant(orgaName));
-            }
+        	String normalizedVal = normalize(splitArray[i], null);
+        	if(normalizedVal != null)
+               	splitArray[i] = normalizedVal;
         }
         
         return Arrays.asList(splitArray);
     }
+    
+	@Override
+	public String getNormalizationMapURL() {
+		return MetadataImporter.config.getOrganisationNamesUrl();
+	}
     
     private String normalizeInputString(String value) {
@@ -54,38 +40,7 @@
     }
 
-    private Map<String, String> getNormalizedOrganisationNamesMap() {
-        if (organisationNamesMap == null) {
-            try {
-                // load records from file, in the future this should be loaded from CLAVAS directly and the file only used as fallback
-                organisationNamesMap = createControlledVocabularyMap(MetadataImporter.config.getOrganisationNamesUrl());
-            } catch (Exception e) {
-                throw new RuntimeException("Cannot instantiate postProcessor:", e);
-            }
-        }
-        return organisationNamesMap;
-    }
 
-    private Map<String, String> createControlledVocabularyMap(String urlToVocabularyFile) throws ParserConfigurationException, MalformedURLException, SAXException, XPathExpressionException, IOException {
-        Map<String, String> result = new HashMap<String, String>();
-        DocumentBuilderFactory domFactory = DocumentBuilderFactory.newInstance();
-        domFactory.setNamespaceAware(true);
-
-        InputStream mappingFileAsStream;
-        mappingFileAsStream = NationalProjectPostProcessor.class.getResourceAsStream(urlToVocabularyFile);
-
-        DocumentBuilder builder = domFactory.newDocumentBuilder();
-        Document doc = builder.parse(mappingFileAsStream);
-        XPath xpath = XPathFactory.newInstance().newXPath();
-        NodeList nodeList = (NodeList) xpath.evaluate("//Organisation", doc, XPathConstants.NODESET);
-        for (int i = 0; i < nodeList.getLength(); i++) {
-            Node node = nodeList.item(i);
-            String organisationName = node.getAttributes().getNamedItem("name").getTextContent();
-            NodeList childNodeList = node.getChildNodes();
-            for (int j = 0; j < childNodeList.getLength(); j++) {
-                String variation = normalizeVariant(childNodeList.item(j).getTextContent());
-                result.put(variation, organisationName);
-            }
-        }
-        return result;
-    }
+	
+    
+    
 }
Index: vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/PostProcessorsWithControlledVocabulary.java
===================================================================
--- vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/PostProcessorsWithControlledVocabulary.java	(revision 6811)
+++ vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/PostProcessorsWithControlledVocabulary.java	(revision 6811)
@@ -0,0 +1,101 @@
+package eu.clarin.cmdi.vlo.importer;
+
+import java.io.File;
+import java.io.FileInputStream;
+import java.io.InputStream;
+import java.nio.file.Path;
+import java.nio.file.Paths;
+import java.util.Map;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import eu.clarin.cmdi.vlo.normalization.pojo.VariantsMap;
+import eu.clarin.cmdi.vlo.normalization.service.NormalizationService;
+import eu.clarin.cmdi.vlo.normalization.service.NormalizationVocabulary;
+import eu.clarin.cmdi.vlo.normalization.service.VariantsMapMarshaller;
+
+/* 
+ * abstract class that encapsulates common map creation from mapping files
+ * for some postprocessors like LanguageCodePostProcessor*
+ * 
+ * brings one more level in class hierarchy between interface PostPorcessor and concrete implementations
+ * 
+ * @author dostojic
+ * 
+ */
+
+public abstract class PostProcessorsWithControlledVocabulary implements PostProcessor, NormalizationService {
+
+	private final static Logger _logger = LoggerFactory.getLogger(PostProcessorsWithControlledVocabulary.class);
+
+	private NormalizationVocabulary vocabulary;
+
+	public String normalize(String value) {
+		return normalize(value, value);
+	}
+
+	public String normalize(String value, String fallBackValue) {
+		if (vocabulary == null)
+			initVocabulary();
+
+		return vocabulary.normalize(value, fallBackValue);
+	}
+
+	public Map<String, String> getCrossMappings(String value) {
+		if (vocabulary == null)
+			initVocabulary();
+
+		return vocabulary.getCrossMappings(value);
+	}
+
+	public abstract String getNormalizationMapURL();
+
+	private void initVocabulary() {
+		VariantsMap varinatsRawMap = getMappingFromFile(getNormalizationMapURL());
+		vocabulary = varinatsRawMap.getMap();
+
+		//printMap();
+	}
+
+	protected VariantsMap getMappingFromFile(String mapUrl) {
+		
+		InputStream is = null;
+		File mapUrlFile = new File(mapUrl);
+		_logger.info("Reading vocabulary file from: {}", mapUrl);
+		// load records from file
+		// in the future this should be loaded from CLAVAS directly and the
+		// file only used as fallback
+		
+		
+		//try from file and if not exists fetch it from classpath (root of the vlo-vocabularies project)
+		Path p = Paths.get(mapUrl);
+		
+		try {
+			is = new FileInputStream(mapUrlFile);
+		} catch (Exception e) {
+			_logger.warn("File {} not found, trying to fetch it from classpath ...", mapUrl);
+			
+			is = PostProcessorsWithControlledVocabulary.class.getClassLoader().getResourceAsStream(mapUrlFile.getName());
+			if(is == null)
+				throw new RuntimeException("Cannot instantiate postProcessor, " + mapUrl + " is not on the classpath");
+		}
+		
+		try{
+			return VariantsMapMarshaller.unmarshal(is);
+		} catch (Exception e) {
+			throw new RuntimeException("Cannot instantiate postProcessor: ", e);
+		}
+			
+		
+	}
+
+	// for debug
+	public void printMap() {
+		_logger.info("map contains {} entries", vocabulary.getEntries().length);
+		for(int i = 0; i < vocabulary.getEntries().length; i++)
+			_logger.info(vocabulary.getEntries()[i].toString());
+			
+
+	}
+}
Index: vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/ResourceClassPostProcessor.java
===================================================================
--- vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/ResourceClassPostProcessor.java	(revision 6810)
+++ vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/ResourceClassPostProcessor.java	(revision 6811)
@@ -4,5 +4,5 @@
 import java.util.List;
 
-public class ResourceClassPostProcessor extends LanguageCodePostProcessor {
+public class ResourceClassPostProcessor implements PostProcessor {
     /**
      * Postprocess ResourceClass values
Index: vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/VLOMarshaller.java
===================================================================
--- vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/VLOMarshaller.java	(revision 6810)
+++ vlo/trunk/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/VLOMarshaller.java	(revision 6811)
@@ -2,4 +2,5 @@
 
 import eu.clarin.cmdi.vlo.config.VloConfig;
+
 import java.io.FileInputStream;
 import java.io.FileNotFoundException;
@@ -11,4 +12,5 @@
 import javax.xml.bind.Marshaller;
 import javax.xml.bind.Unmarshaller;
+
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
@@ -24,18 +26,21 @@
      * @return the facet concept mapping
      */
-    public static FacetConceptMapping getFacetConceptMapping(
-            String facetConcepts) {
+    public static FacetConceptMapping getFacetConceptMapping(String facetConcepts) {
+    	
+    	FacetConceptMapping result;
+    	InputStream is = null;
 
-        if (facetConcepts == null || "".equals(facetConcepts)) {
-            return unmarshal(VLOMarshaller.class.getResourceAsStream(VloConfig.DEFAULT_FACET_CONCEPTS_RESOURCE_FILE));
-        } else {
-            try {
-                return unmarshal(new FileInputStream(facetConcepts));
-            } catch (FileNotFoundException ex) {
+    	try {
+    		is = (facetConcepts == null || "".equals(facetConcepts))?
+    			VLOMarshaller.class.getResourceAsStream(VloConfig.DEFAULT_FACET_CONCEPTS_RESOURCE_FILE) :
+    			new FileInputStream(facetConcepts);
+        } catch (FileNotFoundException e) {
                 logger.error("Could not find facets file: {}", facetConcepts);
                 return null;
-            }
         }
+    	
+    	return unmarshal(is);
     }
+    
 
     /**
@@ -46,14 +51,18 @@
      */
     static FacetConceptMapping unmarshal(InputStream inputStream) {
-        try {
-            JAXBContext jc = JAXBContext.newInstance(FacetConceptMapping.class);
-            Unmarshaller u = jc.createUnmarshaller();
-            FacetConceptMapping result = (FacetConceptMapping) u.unmarshal(inputStream);
-            result.check();
-            return result;
-        } catch (JAXBException e) {
-            throw new RuntimeException(e);
-        }
+        FacetConceptMapping result;
+        
+		try {			
+			JAXBContext jc = JAXBContext.newInstance(FacetConceptMapping.class);
+	        Unmarshaller u = jc.createUnmarshaller();
+	        result = (FacetConceptMapping) u.unmarshal(inputStream);        
+		} catch (JAXBException e) {
+			throw new RuntimeException();
+		}
+		
+		result.check();
+	    return result;
     }
+    
 
     /**
Index: vlo/trunk/vlo-importer/src/test/java/eu/clarin/cmdi/vlo/importer/AvailabilityPostProcessorTest.java
===================================================================
--- vlo/trunk/vlo-importer/src/test/java/eu/clarin/cmdi/vlo/importer/AvailabilityPostProcessorTest.java	(revision 6811)
+++ vlo/trunk/vlo-importer/src/test/java/eu/clarin/cmdi/vlo/importer/AvailabilityPostProcessorTest.java	(revision 6811)
@@ -0,0 +1,23 @@
+package eu.clarin.cmdi.vlo.importer;
+
+import static org.junit.Assert.assertEquals;
+
+import org.junit.Test;
+
+public class AvailabilityPostProcessorTest extends ImporterTestcase {
+    
+
+    @Test
+    public void testLanguageCode() {
+        PostProcessor processor = new AvailabilityPostProcessor();     
+        assertEquals("Free", processor.process("Apache Licence 2.0").get(0));
+        assertEquals("Free", processor.process("Open Access").get(0));
+        assertEquals("Free", processor.process("open access").get(0));
+        assertEquals("Free", processor.process("Open Access").get(0));
+        assertEquals("Free", processor.process("free; Free for academic use.").get(0));
+        assertEquals("Free for academic use", processor.process("CC BY-NC 3.0 DE").get(0));
+        assertEquals("Upon request", processor.process("Please contact contact-person").get(0));
+        
+        
+    }
+}
